mod date;
pub use date::Date;

// pub mod go;

mod game;

mod parser;
use parser::{parse_collection, Tree};

use thiserror::Error;

mod types;
pub use types::*;

/*
pub enum Game {
    Go(go::Game),
    Unsupported(tree::Tree),
}
*/

pub fn parse_sgf(input: &str) -> Result<Vec<Tree>, Error> {
    let (_, trees) = parse_collection::<nom::error::VerboseError<&str>>(input)?;
    Ok(trees)
    /*
    let (_, trees) = parse_collection::<nom::error::VerboseError<&str>>(input)?;
    Ok(trees
        .into_iter()
        .map(|t| match t.root.find_prop("GM") {
            Some(prop) if prop.values == vec!["1".to_owned()] => {
                Game::Go(go::Game::try_from(t).expect("properly structured game tree"))
            }
            _ => Game::Unsupported(t),
        })
        .collect::<Vec<Game>>())
        */
}

/*
impl From<(&str, VerboseErrorKind)> for

impl From<nom::error::VerboseError<&str>> for ParseError {
    fn from(err: nom::error::VerboseError<&str>) -> Self {
        Self::NomErrors(
            err.errors
                .into_iter()
                .map(|err| ParseError::from(err))
                .collect(),
        )
        /*
        Self::NomError(nom::error::Error {
            input: err.input.to_owned(),
            code: err.code.clone(),
        })
        */
    }
}
*/
